/* $Id: ConnectionMonitor.java,v 1.3 2006/08/31 19:04:07 greese Exp $ */
/* Copyright (c) 2006 Valtira Corporation, All Rights Reserved */
package org.dasein.persist;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

public class ConnectionMonitor  implements ServletContextListener {
    private boolean running = false;
    
    public void contextInitialized(ServletContextEvent event) {
        Thread t = new Thread() {
            public void run() {
                synchronized( this ) {
                    running = true;
                    while( running ) {
                        try { wait(60000L); }
                        catch( InterruptedException ignore ) { /* ignore */ }
                        report();
                    }
                }
                System.out.println("Dasein connection monitor is shut down.");
            }
        };
        System.out.println("The Dasein connection monitor is installed and will report every minute.");
        System.out.println("To turn off the Dasein connection monitor, remove the listener entry from your web.xml.");
        t.setDaemon(false);
        t.setName("DASEIN CONNECTION MONITOR");
        t.start();
    }
    
    public void contextDestroyed(ServletContextEvent event) {
        System.out.println("Shutting down the Dasein connection monitor.");
        synchronized( this ) {
            running = false;
            notifyAll();
        }
    }
    
    public void report() {
        Transaction.report();
    }
}
