package org.dasein.persist;

/**
 * <p>
 * Thrown when some database request would result in violating integrity constraints.
 * For example, an application that uses a last modified date to manage concurrent
 * data management might throw this exception if the timestamp has been altered.
 * </p>
 * <p>
 *   Last modified: $Date: 2005/08/15 16:15:59 $
 * </p>
 * @version $Revision: 1.3 $
 * @author George Reese
 */
public class DataIntegrityException extends PersistenceException {
    /**
     * <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3257285816496765232L;

    /**
     * Constructs a new exception without explanation.
     */
    public DataIntegrityException() {
        super();
    }

    /**
     * Constructs a new exception with the specified error message.
     * @param msg a message indicating what happened.
     */
    public DataIntegrityException(String msg) {
        super(msg);
    }
}
