package org.dasein.persist;

public final class Key {
    private String[] fields;
    
    public Key(String ... fields) {
        this.fields = fields;
    }
    
    public boolean equals(Object ob) {
        if( ob == null ) {
            return false;
        }
        if( ob == this ) {
            return true;
        }
        if( !(ob instanceof Key) ) {
            return false;
        }
        Key k = (Key)ob;
        if( k.fields.length != fields.length ) {
            return false;
        }
        for( int i=0; i<fields.length; i++ ) {
            if( !fields[i].equals(k.fields[i]) ) {
                return false;
            }
        }
        return true;
    }
    
    public String[] getFields() {
        return fields;
    }
    
    public boolean matches(SearchTerm ... terms) {
        if( terms == null || terms.length != fields.length ) {
            return false;
        }
        for( int i=0; i<terms.length; i++ ) {
            if( !terms[i].getColumn().equals(fields[i]) ) {
                return false;
            }
        }
        return true;
    }
}
