package org.dasein.persist;

import java.util.Iterator;
import java.util.NoSuchElementException;

public class Range implements Iterable<Integer> {
    int start;
    int end;
    
    public Range(int start, int end) {
        this.start = start;
        this.end = end;
    }
    
    public int getEnd() {
        return end;
    }
    
    public int getStart() {
        return start;
    }
    

    public Iterator<Integer> iterator() {
        return new Iterator<Integer>() {
            private volatile int pointer = start-1;
            
            public boolean hasNext() {
                return (pointer < end);
            }

            public Integer next() {
                if( pointer >= end ) {
                    throw new NoSuchElementException("Maximum of range is " + end);
                }
                pointer++;
                return pointer;
            }

            public void remove() {
                throw new UnsupportedOperationException("It makes absolutely no sense to remove a number from a range.");
            }
        };
    }
}
