package org.dasein.persist;

import org.dasein.persist.jdbc.AutomatedSql.Operator;

public class SearchTerm {
    private String   column;
    private Operator operator;
    private Object   value;
    
    public SearchTerm(String column, Object value) {
        this(column, Operator.EQUALS, value);
    }
    
    public SearchTerm(String column, Operator operator, Object value) {
        this.column = column;
        this.operator = operator;
        this.value = value;
    }
    
    public String getColumn() {
        return column;
    }
    
    public Operator getOperator() {
        return operator;
    }
    
    public Object getValue() {
        return value;
    }
    
    public String toString() {
        return (column + " " + operator + " " + value);
    }
}
