package org.dasein.persist.attributes;

import java.sql.SQLException;
import java.util.Map;

import org.dasein.persist.Execution;
import org.dasein.persist.PersistenceException;
import org.dasein.persist.Transaction;

public class RemoveAttributes extends Execution {
    static private final int OWNER_CLASS = 1;
    static private final int OWNER_ID    = 2;

    private String sql = null;
    
    public synchronized String getStatement() throws SQLException {
        if( sql == null ) {
            StringBuffer str = new StringBuffer();
            
            str.append("DELETE FROM ");
            str.append(getIdentifier(LoadAttributes.ATTRIBUTE_TABLE));
            str.append(" WHERE ");
            str.append(getIdentifier("owner_class"));
            str.append(" = ? AND ");
            str.append(getIdentifier("owner_id"));
            str.append(" = ?");
            sql = str.toString();
        }
        return sql;
    }
    
    public Map<String, Object> run(Transaction xaction, Map<String,Object> params) throws PersistenceException, SQLException {
        String cname = (String)params.get(AttributeDAO.OWNER_CLASS);
        String id = (String)params.get(AttributeDAO.OWNER_ID);
        
        statement.setString(OWNER_CLASS, cname);
        statement.setString(OWNER_ID, id);
        statement.executeUpdate();
        return null;
    }
}
    
