package org.dasein.persist.attributes;

import java.sql.SQLException;
import java.util.Map;

import org.dasein.persist.Execution;
import org.dasein.persist.PersistenceException;
import org.dasein.persist.Transaction;

public class RemoveTypes extends Execution {
    static private final int OBJECT_TYPE  = 1;
    static private final int OBJECT_ID    = 2;

    private String sql = null;
    
    public synchronized String getStatement() throws SQLException {
        if( sql == null ) {
            StringBuffer str = new StringBuffer();
            
            str.append("DELETE FROM ");
            str.append(getIdentifier(LoadTypes.TYPE_TABLE));
            str.append(" WHERE ");
            str.append(getIdentifier("type_class"));
            str.append(" = ? AND ");
            str.append(getIdentifier("type_id"));
            str.append(" = ?");
            sql = str.toString();
        }
        return sql;
    }
    
    public Map<String, Object> run(Transaction xaction, Map<String,Object> params) throws PersistenceException, SQLException {
        String cname = (String)params.get(AttributeDAO.TYPE_CLASS);
        String id = (String)params.get(AttributeDAO.TYPE_ID);
        
        statement.setString(OBJECT_TYPE, cname);
        if( id == null ) {
            id = "";
        }
        statement.setString(OBJECT_ID, id);
        statement.executeUpdate();
        return null;
    }
}
    
