/* $Id: Counter.java,v 1.1 2006/07/24 14:29:25 greese Exp $ */
/* Copyright (c) 2006 Valtira Corporation, All Rights Reserved */
package org.dasein.persist.jdbc;

import java.sql.SQLException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.dasein.persist.PersistenceException;
import org.dasein.persist.Transaction;

public class Counter extends AutomatedSql {
    private String                   sql        = null;
    
    public Counter() {
        super();
    }
    
    public synchronized String getStatement() throws SQLException {
        if( sql == null ) {
            StringBuffer str = new StringBuffer();

            str.append("SELECT COUNT( * ) FROM ");
            str.append(getIdentifier(getTableName()));
            if( !getCriteria().isEmpty() ) {
                Iterator<Criterion> criteria;
                
                str.append(" WHERE ");
                criteria = getCriteria().iterator();
                while( criteria.hasNext() ) {
                    Criterion criterion = criteria.next();
                    
                    str.append(getIdentifier(getTableName(), getSqlName(criterion.column)));
                    str.append(" ");
                    str.append(criterion.operator.toString());
                    str.append(" ?");
                    if( criteria.hasNext() ) {
                        str.append(" ");
                        str.append(getJoin().toString());
                        str.append(" ");
                    }
                }
            }
            sql = str.toString();
        }
        return sql;
    }
    
    public void prepare(Map<String,Object> params) throws SQLException {
        int i = 1;
        
        for( Criterion criterion : getCriteria() ) {
            prepare(criterion.column, i++, params.get(criterion.column));
        }
    }
    
    public Map<String,Object> run(Transaction xaction, Map<String,Object> params) throws SQLException, PersistenceException {
        HashMap<String,Object> map = new HashMap<String,Object>();
        
        prepare(params);
        results = statement.executeQuery();
        if( results.next() ) {
            map.put("count", results.getLong(1));
        }
        else {
            map.put("count", 0);
        }
        return map;
    }
}
