package org.dasein.persist.jdbc;

import org.dasein.persist.Execution;

public abstract class TranslationSql extends Execution {
    protected String getSqlNameForClassName(String cname) {
        String[] parts = cname.split("\\.");
        int i;
        
        if( parts != null && parts.length > 1 ) { 
            cname = parts[parts.length-1];
        }
        i = cname.lastIndexOf("$");
        if( i != -1 ) {
            cname = cname.substring(i+1);
        }                
        return getSqlName(cname);
    }
    
    protected String getSqlName(Class cls) {
        return getSqlNameForClassName(cls.getName());
    }
    
    protected String getSqlName(String nom) {
        StringBuffer sql = new StringBuffer();
        
        for(int i=0; i<nom.length(); i++) {
            char c = nom.charAt(i);
            
            if( Character.isLetter(c) && !Character.isLowerCase(c) ) {
                if( i != 0 ) {
                    sql.append("_");
                }
                sql.append(Character.toLowerCase(c));
            }
            else {
                sql.append(c);
            }
        }
        return sql.toString();
    }
}
