/* $Id: TranslatorDeleter.java,v 1.2 2007/08/05 18:42:57 greese Exp $ */
/* Copyright (c) 2005-2007 Valtira LLC, All Rights Reserved */
package org.dasein.persist.jdbc;

import java.sql.SQLException;
import java.util.Map;

import org.dasein.persist.PersistenceException;
import org.dasein.persist.Transaction;

/**
 * <p>
 *   Provides basic operations to delete translations associated with a specific object from the database.
 * </p>
 * <p>
 *   Last modified: $Date: 2007/08/05 18:42:57 $
 * </p>
 * @version $Revision: 1.2 $
 * @author George Reese
 */
public abstract class TranslatorDeleter extends TranslationSql {
    static public final int W_OWNER_ID    = 1;
    
    private String sql = null;
    
    public String getStatement() throws SQLException {
        if( sql == null ) {
            StringBuffer str = new StringBuffer();
            String tbl = getTable();
            
            str.append("DELETE FROM ");
            str.append(getIdentifier(tbl));
            str.append(" WHERE ");
            str.append(getIdentifier("owner_id"));
            str.append("  = ?");
            if( getConnection() == null ) {
                return str.toString();
            }
            sql = str.toString();
        }
        return sql;
    }
    
    public abstract String getTable();
    
    public Map<String, Object> run(Transaction xaction, Map<String,Object> state) throws PersistenceException, SQLException {
        Object id = state.get("ownerId");

        statement.setString(W_OWNER_ID, id.toString());
        statement.executeUpdate();
        return null;
    }
}
